/*
* Agent.cpp
*
*  Created on: Dec 4, 2014
*      Author: jungk_000
*/

#include "Agent.h"

Agent::Agent(vector<unsigned short int> &genome_0_New, vector<unsigned short int> &genome_1_New, int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE)
{
	int i;
	int end_0 = (*num_Locus);

	genome = new unsigned short int*[end_0];

	for (i = 0; i < end_0; i++){
		genome[i] = new unsigned short int[2];//two positions for each locus
	}//end locus loop

	for (i = 0; i < end_0; i++){
		genome[i][0] = genome_0_New[i];
		genome[i][1] = genome_1_New[i];
	}//end locus loop

	end_0 = (*num_Trait);
	trait = new int[end_0];

	for (i = 0; i < end_0; i++){
		trait[i] = p_Trait[i];
	}//end locus loop	

	num_Allele_BodyLength = (double)trait[0];

	status_Sexual_Maturation = false;

	//sets null bodylength
	Set_BodyLength_Null();

	age = 0.0;
	m_CE = (*p_CE);
}//end constructor

Agent::~Agent(void)
{

}//end destructor

void Agent::Deallocation_Memory(int num_Locus)
{
	int locus;

	for (locus = 0; locus < num_Locus; locus++){
		delete[] genome[locus];
	}//end locus loop

	delete[] genome;
	delete[] trait;
}

void Agent::Set_Genome(vector<unsigned short int> &genome_0_New, vector<unsigned short int> &genome_1_New, int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE)
{
	int i;
	int end_0 = (*num_Locus);

	for (i = 0; i < end_0; i++){
		genome[i][0] = genome_0_New[i];
		genome[i][1] = genome_1_New[i];
	}//end locus loop

	end_0 = (*num_Trait);

	for (i = 0; i < end_0; i++){
		trait[i] = p_Trait[i];	
	}//end locus loop

	num_Allele_BodyLength = (double)trait[0];
	m_CE = (*p_CE);
}

void Agent::Set_Trait(int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE)
{
	int i;
	int end_0 = (*num_Trait);

	for (i = 0; i < end_0; i++){
		trait[i] = p_Trait[i];
	}//end locus loop

	num_Allele_BodyLength = (double)trait[0];
	m_CE = (*p_CE);
}

unsigned short int** Agent::Get_Genome(void)
{
	return genome;//returns the pointer for genome
}

void Agent::Bi_Allele_Flip(int *p_Locus, int *p_Position){
	//Change allele 0 -> 1, 1 -> 0
	if (genome[(*p_Locus)][(*p_Position)] == 0)
	{
		genome[(*p_Locus)][(*p_Position)] = 1;
	}
	else
	{
		genome[(*p_Locus)][(*p_Position)] = 0;
	}//end else

	//genome[(*p_Locus)][(*p_Position)] = abs((genome[(*p_Locus)][(*p_Position)] - 1));
}

int* Agent::Get_Trait(void){
	return trait;
}

void Agent::Get_Trait_0(int *p_Trt0){
	(*p_Trt0) = trait[0];
}

void Agent::Get_Trait_Raw(int *p_Trait_Value, int *p_Trait_Number){
	(*p_Trait_Value) = trait[(*p_Trait_Number)];
}

void Agent::Get_Status_Sexual_Maturation(bool *p_Status_Sexual_Maturation){
	(*p_Status_Sexual_Maturation) = status_Sexual_Maturation;
}

void Agent::Set_Status_Sexual_Maturation(bool *p_Status_Sexual_Maturation){
	status_Sexual_Maturation = (*p_Status_Sexual_Maturation);
}

void Agent::Reset_Status_Sexual_Maturation(void){
	status_Sexual_Maturation = false;
}

void Agent::Activate_Status_Sexual_Maturation(void){
	status_Sexual_Maturation = true;
}

//void Agent::Get_BodyLength_Bin_Number(int *p_BodyLength_Bin_Number)
//{
	//(*p_BodyLength_Bin_Number) = bodyLength_Bin_Number;
//}

//void Agent::Set_Bin_Number_BodyLength_Unit(double *p_Min_BodyLength, double *p_Bin_Width)
//{
	//bodyLength_Bin_Number = (int)((bodyLength - (*p_Min_BodyLength)) / (*p_Bin_Width));
//}

void Agent::Get_BodyLength(double *p_BodyLength)
{
	(*p_BodyLength) = bodyLength;
}

void Agent::Set_BodyLength(double *p_BodyLength)
{
	bodyLength = (*p_BodyLength);
}

void Agent::Set_BodyLength_Null(void)
{//sets null bodylength
	bodyLength = 0.0;
}

void Agent::Get_GillRaker_Genotype(int *p_GillRaker_Genotype)
{//returns gillraker genotype
	(*p_GillRaker_Genotype) = trait[1];
}

void Agent::Get_Bin_Number_BodyLength_Foraging(int *p_BodyLength_Bin_Number)
{
	(*p_BodyLength_Bin_Number) = bin_Number_BodyLength_Foraging;
}

void Agent::Set_Bin_Number_BodyLength_Foraging(int *p_BodyLength_Bin_Number)
{
	bin_Number_BodyLength_Foraging = (*p_BodyLength_Bin_Number);
}

void Agent::Get_BodyLength_Genotype(int *p_BodyLength_Genotype)
{//returns the genotype for bodylength trait
	(*p_BodyLength_Genotype) = trait[0];
}

void Agent::Get_Num_Allele_BodyLength_Double(double *p_Num_Allele_BodyLength)
{
	(*p_Num_Allele_BodyLength) = num_Allele_BodyLength;
}

void Agent::Set_Age(double *p_Age)
{
	age = (*p_Age);
}

void Agent::Set_Age_Zero(void)
{
	age = 0.0;
}

void Agent::Get_Age(double *p_Age)
{
	(*p_Age) = age;
}

void Agent::Increase_Age(double *p_TimeStep)
{
	age += (*p_TimeStep);
}

void Agent::Set_CE(double *p_CE)
{
	m_CE = (*p_CE);
}

void Agent::Get_CE(double *p_CE)
{
	(*p_CE) = m_CE;
}