/*
* Agent.h
*
*  Created on: Dec 4, 2014
*      Author: jungk_000
*/

#ifndef AGENT_H_
#define AGENT_H_

#include <vector>
#include <cmath>

using namespace std;

class Agent {
private:
	//sexual maturation status: true: sexually matured, false: sexually not matured
	bool status_Sexual_Maturation;
	//bodylength
	double bodyLength;
	//age
	double age;
	//the number of allele determining bodylength in double
	double num_Allele_BodyLength;	
	//the bin number for bodylength regarding foraging
	int bin_Number_BodyLength_Foraging;
	//ce: the effect of environment on bodylength growth
	double m_CE;
public:
	unsigned short int** genome;//dim[locus, position]genetic information[locus]
	int *trait;//trait

	Agent(vector<unsigned short int> &genome_0_New, vector<unsigned short int> &genome_1_New, int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE);
	virtual ~Agent();

	//sets a genome
	void Set_Genome(vector<unsigned short int> &genome_0_New, vector<unsigned short int> &genome_1_New, int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE);

	//sets traits
	void Set_Trait(int *num_Locus, vector<int> &p_Trait, int *num_Trait, double *p_CE);

	//switches allele 0 to 1 or 1 to 0 
	void Bi_Allele_Flip(int *p_Locus, int *p_Position);

	//Returns
	unsigned short int** Get_Genome(void);
	int* Get_Trait(void);//returns vital rates
	void Get_Trait_0(int *p_Trt0);//returns vital rates
	//returns trait value for a specific trait 
	void Get_Trait_Raw(int *p_Trait_Value, int *p_Trait_Number);

	void Get_Status_Sexual_Maturation(bool *p_Status_Sexual_Maturation);
	//void Get_BodyLength_Bin_Number(int *p_BodyLength_Bin_Number);

	//sets the bin number for the bodylength
	void Set_Bin_Number_BodyLength_Foraging(int *p_BodyLength_Bin_Number);
	//returns the bin number for bodylength for foraging
	void Get_Bin_Number_BodyLength_Foraging(int *p_BodyLength_Bin_Number);

	//sets body length
	void Set_BodyLength(double *p_BodyLength);

	//returns bodylength
	void Get_BodyLength(double *p_BodyLength);

	//returns the genotype for bodylength trait
	void Get_BodyLength_Genotype(int *p_BodyLength_Genotype);

	//sets null bodylength
	void Set_BodyLength_Null(void);

	//returns gillraker genotype
	void Get_GillRaker_Genotype(int *p_GillRaker_Genotype);

	//returns the number of allele determining bodylength in double
	void Get_Num_Allele_BodyLength_Double(double *p_Num_Allele_BodyLength);

	//Set
	void Set_Status_Sexual_Maturation(bool *p_Status_Sexual_Maturation);
	//Reset
	void Reset_Status_Sexual_Maturation(void);
	//Activation
	void Activate_Status_Sexual_Maturation(void);
	
	//set age
	void Set_Age(double *p_Age);
	//set age to 0.0
	void Set_Age_Zero(void);
	//return age
	void Get_Age(double *p_Age);
	//increase age
	void Increase_Age(double *p_TimeStep);

	//set ce
	void Set_CE(double *p_CE);
	//get ce
	void Get_CE(double *p_CE);

	//Memory deallocation
	void Deallocation_Memory(int num_Locus);
};

#endif /* AGENT_H_ */
