#include "Batch_Analysis.h"


Batch_Analysis::Batch_Analysis(vector<int> &p_Num_Class)
{
	//vector<int> &p_Num_Class: this vector contains the number of class for each category
	//i.e. the number of class = p_Num_Class[category number #1];
	//
	//i.e. if the numbers of classes for category #1,2,3,4,5, and 6 are 2,2,2,2,2,2,2, and 2, respectively
	//p_Num_Class[0] = 2;
	//p_Num_Class[1] = 2;
	//p_Num_Class[2] = 2;
	//p_Num_Class[3] = 2;
	//p_Num_Class[4] = 2;
	//p_Num_Class[5] = 2;
	//p_Num_Class[6] = 2;
	num_Category = 7;//the number of categories

	int i;
	int num_Elements = (int)p_Num_Class.size();

	for (i = 0; i < num_Elements; i++)
	{
		num_Class.push_back(p_Num_Class[i]);
	}//end
}

Batch_Analysis::~Batch_Analysis()
{
}

string Batch_Analysis::Count_Threshold(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int start_Row, int end_Row, vector<int> &state_Column, vector<double> &p_Constant, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6)
{
	cout << "Batch  Analysis (count)" << endl;
	//string id_Tag: the name for identifying the output file
	//i.e. string id_Tag = "test";

	//vector<string> fileNameVector: file name vector
	//vector<int> cat0::category 1 for a file
	//vector<int> cat1::category 2 for a file

	//vector<double> &p_Constant: constants for condition for the columns (excluding the columns not containing data)
	//i.e. p_Constant[0] = 1.0

	//vector<int> &state_Column: the state of data column (excluding the columns not containing data)
	//to return true all conditions for all columns should be true
	//0: no count
	//1: (x < p_Constant[column])
	//2: (x > p_Constant[column])
	//3: (x <= p_Constant[column])
	//4: (x >= p_Constant[column])
	//5: (x == p_Constant[column])

	//int start_Row: the sequence of the row in the data (except headers) for starting to count
	//i.e. For the first row: start_Row = 1;

	//int end_Row: the sequence of the row n the data (except headers) that the counting ends
	//i.e. for the 300th row in the data (except headers) end_Row = 300;
	Counter_Unit c_Unit(num_Class);//counter unit memory allocation
	File_RW fileRW;
	int num_Files = (int)fileNameVector.size();//the number of files
	int i;
	int num_Rows_Raw, num_Columns_Raw;//the numbers of rows and columns in a raw data file
	int num_Rows_Data, num_Columns_Data;
	vector<int> category_Set(num_Category); //category set
	bool state_Threshold;//the state of meeting the conditions
	int row, column;
	int tmp_Start_Row, tmp_End_Row;
	int timer_Step;//timer for checking steps

	//data processing
	//checks conditions and waiting time
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Count 1/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);
		//cout << "ok0 " << num_Rows_Raw << " " << num_Columns_Raw<<endl;

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes
		//cout << "ok1 ";

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);
		//cout << "ok2 "<<" size"<<category_Set.size()<<endl;

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector
		state_Threshold = false;//resets the state

		tmp_Start_Row = start_Row - 1;//resets the row for starting to count

		if (tmp_Start_Row > num_Rows_Data)
		{
			tmp_Start_Row = num_Rows_Data - 1;//resets the row for starting to count
		}//end if

		tmp_End_Row = end_Row;

		if (tmp_End_Row > num_Rows_Data)
		{
			tmp_End_Row = num_Rows_Data;
		}//end if

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		bool count_State;
		double tmp_Duration = 0.0;
		timer_Step = 0;//timer for checking steps

		for (row = tmp_Start_Row; row < tmp_End_Row; row++)
		{
			state_Threshold = false;//resets the state
			count_State = false;//resets the count state

			for (column = 0; column < num_Columns_Data; column++)
			{
				//checks if an element meets the condition
				//vector<bool> &state_Column: the state of column
				//to return true all conditions for all columns should be true
				//0: no count
				//1: (x < p_constant)
				//2: (x > p_constant)
				//3: (x <= p_constant)
				//4: (x >= p_constant)
				//5: (x == p_constant)
				switch (state_Column[column])
				{
				case 0:
					break;
				case 1:
					if (tmp_Dbl_Data[row][column] < p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 2:
					if (tmp_Dbl_Data[row][column] > p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 3:
					if (tmp_Dbl_Data[row][column] <= p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 4:
					if (tmp_Dbl_Data[row][column] >= p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 5:
					if (tmp_Dbl_Data[row][column] == p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				default:
					break;
				}//end switch

				if (count_State == true)
				{//if counting happened
					if (state_Threshold == false)
					{
						break;
					}//end if
				}//end if
			}//end column loop						

			if (state_Threshold == true)
			{
				break;
			}//end if
			//////////////////////////////////////////
			//////////////////////////////////////////
			//////////////////////////////////////////
		}//end row loop

		//calculates duration
		tmp_Duration = ((double)(timer_Step));

		c_Unit.Update_Counter_Sum_Duration(category_Set, &state_Threshold, &tmp_Duration);
		timer_Step++;//timer for checking steps
	}//end file loop

	//calculates mean durations
	c_Unit.Set_Mean_Duration();

	//data processing
	//calculates sum of squared difference
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Count 2/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);
		//cout << "ok0 " << num_Rows_Raw << " " << num_Columns_Raw<<endl;

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes
		//cout << "ok1 ";

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);
		//cout << "ok2 "<<" size"<<category_Set.size()<<endl;

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector
		state_Threshold = false;//resets the state

		tmp_Start_Row = start_Row - 1;//resets the row for starting to count

		if (tmp_Start_Row > num_Rows_Data)
		{
			tmp_Start_Row = num_Rows_Data - 1;//resets the row for starting to count
		}//end if

		tmp_End_Row = end_Row;

		if (tmp_End_Row > num_Rows_Data)
		{
			tmp_End_Row = num_Rows_Data;
		}//end if

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		bool count_State;
		double tmp_Duration = 0.0;
		timer_Step = 0;//timer for checking steps

		for (row = tmp_Start_Row; row < tmp_End_Row; row++)
		{
			state_Threshold = false;//resets the state
			count_State = false;//resets the count state

			for (column = 0; column < num_Columns_Data; column++)
			{
				//checks if an element meets the condition
				//vector<bool> &state_Column: the state of column
				//to return true all conditions for all columns should be true
				//0: no count
				//1: (x < p_constant)
				//2: (x > p_constant)
				//3: (x <= p_constant)
				//4: (x >= p_constant)
				//5: (x == p_constant)
				switch (state_Column[column])
				{
				case 0:
					break;
				case 1:
					if (tmp_Dbl_Data[row][column] < p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 2:
					if (tmp_Dbl_Data[row][column] > p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 3:
					if (tmp_Dbl_Data[row][column] <= p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 4:
					if (tmp_Dbl_Data[row][column] >= p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				case 5:
					if (tmp_Dbl_Data[row][column] == p_Constant[column])
					{
						state_Threshold = true;//resets the state						
					}//end if

					count_State = true;//resets the count state
					break;
				default:
					break;
				}//end switch

				if (count_State == true)
				{//if counting happened
					if (state_Threshold == false)
					{
						break;
					}//end if
				}//end if
			}//end column loop						

			if (state_Threshold == true)
			{
				break;
			}//end if
			//////////////////////////////////////////
			//////////////////////////////////////////
			//////////////////////////////////////////
		}//end row loop

		//calculates duration
		tmp_Duration = ((double)(timer_Step));

		c_Unit.Update_Counter_Squared_Difference_Duration(category_Set, &state_Threshold, &tmp_Duration);
		timer_Step++;//timer for checking steps
	}//end file loop

	//calculates standard deviations for waiting time
	c_Unit.Set_SD_Duration();

	//sets the output file
	string fileName_Output = "ct_" + id_Tag;//output file name
	//writes the results of the counter

	fileName_Output = c_Unit.Write_Output_File(&fileName_Output);

	//de-allocates memory
	c_Unit.De_Allocate_Memory();

	return fileName_Output;
}

string Batch_Analysis::Set_Mean_SD(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Row_Selected, int p_Column_Selected, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6)
{
	cout << "Batch  Analysis (Summation)" << endl;
	//string id_Tag: the name for identifying the output file
	//i.e. string id_Tag = "test";

	//vector<string> fileNameVector: file name vector
	//vector<int> cat0::category 1 for a file
	//vector<int> cat1::category 2 for a file

	//vector<double> &p_Constant: constants for condition for the columns (excluding the columns not containing data)
	//i.e. p_Constant[0] = 1.0

	//vector<int> &state_Column: the state of data column (excluding the columns not containing data)
	//to return true all conditions for all columns should be true
	//0: no count
	//1: (x < p_Constant[column])
	//2: (x > p_Constant[column])
	//3: (x <= p_Constant[column])
	//4: (x >= p_Constant[column])
	//5: (x == p_Constant[column])

	//int p_Row_Selected: the sequence of the row in the data (except headers) for starting to count
	//i.e. For the first row: start_Row = 1;

	//int end_Row: the sequence of the row n the data (except headers) that the counting ends
	//i.e. for the 300th row in the data (except headers) end_Row = 300;
	Sum_Unit s_Unit(num_Class);
	File_RW fileRW;
	int num_Files = (int)fileNameVector.size();//the number of files
	int i;
	int num_Rows_Raw, num_Columns_Raw;//the numbers of rows and columns in a raw data file
	int num_Rows_Data, num_Columns_Data;
	vector<int> category_Set(num_Category); //category set

	p_Row_Selected = p_Row_Selected - 1;//resets the selected row
	p_Column_Selected = p_Column_Selected - 1;//resets the selected column

	//data processing
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Summation 1/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		s_Unit.Update_Sum(category_Set, &tmp_Dbl_Data[p_Row_Selected][p_Column_Selected]);
	}//end file loop

	//sets means
	s_Unit.Set_Mean();

	//calculates the sum of squared differences
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Summation 2/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		s_Unit.Update_Squared_Sum_Difference(category_Set, &tmp_Dbl_Data[p_Row_Selected][p_Column_Selected]);
	}//end file loop

	//calculates standard deviations
	s_Unit.Set_SD();

	//sets the output file
	string fileName_Output = "mu_" + id_Tag;//output file name
	//writes the results of the counter
	fileName_Output = s_Unit.Write_Output_File(&fileName_Output);

	//de-allocates memory
	s_Unit.De_Allocate_Memory();

	return fileName_Output;
}

string Batch_Analysis::Set_Mean_SD_Batch_Row(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Row_Selected, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6)
{
	cout << "Batch  Analysis (Summation) Row Operation" << endl;
	//string id_Tag: the name for identifying the output file
	//i.e. string id_Tag = "test";

	//vector<string> fileNameVector: file name vector
	//vector<int> cat0::category 1 for a file
	//vector<int> cat1::category 2 for a file

	//vector<double> &p_Constant: constants for condition for the columns (excluding the columns not containing data)
	//i.e. p_Constant[0] = 1.0

	//vector<int> &state_Column: the state of data column (excluding the columns not containing data)
	//to return true all conditions for all columns should be true
	//0: no count
	//1: (x < p_Constant[column])
	//2: (x > p_Constant[column])
	//3: (x <= p_Constant[column])
	//4: (x >= p_Constant[column])
	//5: (x == p_Constant[column])

	//int p_Row_Selected: the sequence of the row in the data (except headers) for starting to count
	//i.e. For the first row: start_Row = 1;

	//int end_Row: the sequence of the row n the data (except headers) that the counting ends
	//i.e. for the 300th row in the data (except headers) end_Row = 300;

	File_RW fileRW;
	int num_Files = (int)fileNameVector.size();//the number of files
	int i, j, k;
	int num_Rows_Raw, num_Columns_Raw;//the numbers of rows and columns in a raw data file
	int num_Rows_Data, num_Columns_Data;
	vector<int> category_Set(num_Category); //category set

	p_Row_Selected = p_Row_Selected - 1;//resets the selected row

	//gets the number of data rows processing
	for (i = 0; i < 1; i++)
	{
		cout << "Initial Data Process" << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector
	}//end file loop

	vector<Sum_Unit*> s_Unit_M;//one summation unit for each data column

	for (i = 0; i < num_Columns_Data; i++)
	{//allocate memory for summation units
		s_Unit_M.push_back(new Sum_Unit(num_Class));
	}//end i loop

	//data processing
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Summation 1/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		for (j = 0; j < num_Columns_Data; j++)
		{//allocate memory for summation units
			s_Unit_M[j]->Update_Sum(category_Set, &tmp_Dbl_Data[p_Row_Selected][j]);
		}//end i loop
	}//end file loop

	//sets means
	for (i = 0; i < num_Columns_Data; i++)
	{
		s_Unit_M[i]->Set_Mean();
	}//end i loop

	//calculates the sum of squared differences
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Summation 2/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends
		//sets means
		for (j = 0; j < num_Columns_Data; j++)
		{
			s_Unit_M[j]->Update_Squared_Sum_Difference(category_Set, &tmp_Dbl_Data[p_Row_Selected][j]);
		}//end i loop
	}//end file loop

	//calculates standard deviations
	for (i = 0; i < num_Columns_Data; i++)
	{
		s_Unit_M[i]->Set_SD();
	}//end i loop

	//sets the output file
	string fileName_Output_Str = "mu_" + id_Tag + ".csv";//output file name
	int size_String = (int)fileName_Output_Str.length();
	char *fileName_Output = new char[(size_String + 1)];//one more cell for ending character array	
	//the number of cells in char* should be (the length of string + 1)
	fileRW.Copy_String_To_Char_Arr(fileName_Output_Str, fileName_Output);//copy string and paste on char*
	fileRW.CSV_Create(fileName_Output);//creates a csv file

	//gets the results of the summation units
	int size_Row, size_Column;

	//gets result data size
	for (i = 0; i < num_Columns_Data; i++)
	{////de-allocates memory
		vector<vector<double>> tmp_Data;
		s_Unit_M[i]->Get_Vector_Double_Data(tmp_Data);

		size_Row = (int)tmp_Data.size();
		size_Column = (int)tmp_Data[0].size();
	}//end i loop

	//the number of data columns
	int num_Data_Columns = size_Column * num_Columns_Data;

	vector<vector<string>> header;
	header.resize(1, vector<string>(num_Data_Columns));

	vector<vector<double>> data_Set(size_Row, vector<double>(num_Data_Columns));

	int cnt_0 = 0;
	int column_Counter = 0;

	//collectes output data from summation units
	for (i = 0; i < num_Columns_Data; i++)
	{//
		vector<vector<string>> tmp_Header;
		s_Unit_M[i]->Get_Vector_String_Column_Header(tmp_Header);

		size_Row = (int)tmp_Header.size();
		size_Column = (int)(int)tmp_Header[0].size();

		for (j = 0; j < size_Row; j++)
		{
			for (k = 0; k < size_Column; k++)
			{//column headers
				header[j][(k + (i * size_Column))] = tmp_Header[j][k];
			}//end column loop
		}//end column loop

		vector<vector<double>> tmp_Data;
		s_Unit_M[i]->Get_Vector_Double_Data(tmp_Data);

		size_Row = (int)tmp_Data.size();
		size_Column = (int)(int)tmp_Data[0].size();

		for (j = 0; j < size_Row; j++)
		{
			for (k = 0; k < size_Column; k++)
			{//data
				data_Set[j][(k + (i * size_Column))] = tmp_Data[j][k];
			}//end column loop
		}//end column loop
	}//end i loop

	fileRW.CSV_Write_Add_String_2D_Vector(fileName_Output, header);//writes column headers on a file
	fileRW.CSV_Write_Add_Double_2D_Vector(fileName_Output, data_Set);//writes data on a file

	for (i = 0; i < num_Columns_Data; i++)
	{//de-allocates memory
		s_Unit_M[i]->De_Allocate_Memory();
	}//end i loop

	delete[] fileName_Output;

	return fileName_Output_Str;
}

string Batch_Analysis::Set_Max_Stat(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Column_Selected, int start_Row, int end_Row, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6)
{
	cout << "Batch  Analysis (Maximum)" << endl;
	//string id_Tag: the name for identifying the output file
	//i.e. string id_Tag = "test";

	//vector<string> fileNameVector: file name vector

	//int p_Column_Selected: selected column for caculating statistics
	//i.e. the fourth row in data: p_Column_Selected = 4;

	//int start_row: the sequence of the row in the data (except headers) for starting to count
	//i.e. For the first row: start_Row = 1;

	//int end_Row: the sequence of the row n the data (except headers) that the counting ends
	//i.e. for the 300th row in the data (except headers) end_Row = 300;
	Sum_Unit s_Unit(num_Class);
	File_RW fileRW;
	int num_Files = (int)fileNameVector.size();//the number of files
	int i, j;
	int num_Rows_Raw, num_Columns_Raw;//the numbers of rows and columns in a raw data file
	int num_Rows_Data, num_Columns_Data;
	vector<int> category_Set(num_Category); //category set
	double tmp_Max;

	start_Row = start_Row - 1;
	p_Column_Selected = p_Column_Selected - 1;//resets the selected column

	//data processing
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Maximum 1/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends

		//initialization
		tmp_Max = tmp_Dbl_Data[start_Row][p_Column_Selected];

		for (j = start_Row; j < end_Row; j++)
		{
			if (tmp_Dbl_Data[j][p_Column_Selected] > tmp_Max)
			{
				tmp_Max = tmp_Dbl_Data[j][p_Column_Selected];
			}//end if
		}//end data row loop

		s_Unit.Update_Sum(category_Set, &tmp_Max);
	}//end file loop

	//sets means
	s_Unit.Set_Mean();

	//calculates the sum of squared differences
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Maximum 2/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends

		//initialization
		tmp_Max = tmp_Dbl_Data[start_Row][p_Column_Selected];

		for (j = start_Row; j < end_Row; j++)
		{
			if (tmp_Dbl_Data[j][p_Column_Selected] > tmp_Max)
			{
				tmp_Max = tmp_Dbl_Data[j][p_Column_Selected];
			}//end if
		}//end data row loop

		s_Unit.Update_Squared_Sum_Difference(category_Set, &tmp_Max);
	}//end file loop

	//calculates standard deviations
	s_Unit.Set_SD();

	//sets the output file
	string fileName_Output = "mx_" + id_Tag;//output file name
	//writes the results of the counter
	fileName_Output = s_Unit.Write_Output_File(&fileName_Output);

	//de-allocates memory
	s_Unit.De_Allocate_Memory();

	return fileName_Output;
}

string Batch_Analysis::Set_Min_Stat(string id_Tag, vector<string> fileNameVector, int num_Row_Skip, int num_Col_Skip, int p_Column_Selected, int start_Row, int end_Row, vector<int> cat0, vector<int> cat1, vector<int> cat2, vector<int> cat3, vector<int> cat4, vector<int> cat5, vector<int> cat6)
{
	cout << "Batch  Analysis (Minimum)" << endl;
	//string id_Tag: the name for identifying the output file
	//i.e. string id_Tag = "test";

	//vector<string> fileNameVector: file name vector

	//int p_Column_Selected: selected column for caculating statistics
	//i.e. the fourth row in data: p_Column_Selected = 4;

	//int start_row: the sequence of the row in the data (except headers) for starting to count
	//i.e. For the first row: start_Row = 1;

	//int end_Row: the sequence of the row n the data (except headers) that the counting ends
	//i.e. for the 300th row in the data (except headers) end_Row = 300;

	Sum_Unit s_Unit(num_Class);
	File_RW fileRW;
	int num_Files = (int)fileNameVector.size();//the number of files
	int i, j;
	int num_Rows_Raw, num_Columns_Raw;//the numbers of rows and columns in a raw data file
	int num_Rows_Data, num_Columns_Data;
	vector<int> category_Set(num_Category); //category set
	double tmp_Min;

	start_Row = start_Row - 1;
	p_Column_Selected = p_Column_Selected - 1;//resets the selected column

	//data processing
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Minimum 1/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends

		//initialization
		tmp_Min = tmp_Dbl_Data[start_Row][p_Column_Selected];

		for (j = start_Row; j < end_Row; j++)
		{
			if (tmp_Dbl_Data[j][p_Column_Selected] < tmp_Min)
			{
				tmp_Min = tmp_Dbl_Data[j][p_Column_Selected];
			}//end if
		}//end data row loop

		s_Unit.Update_Sum(category_Set, &tmp_Min);
	}//end file loop

	//sets means
	s_Unit.Set_Mean();

	//calculates the sum of squared differences
	for (i = 0; i < num_Files; i++)
	{
		cout << "Process Minimum 2/2: File Sequence: " << (i + 1) << "/" << num_Files << endl;
		vector<vector<string>> tmp_Str_Data;//temporary string data

		//imports raw string data
		fileRW.CSV_Read_String_2D_String(fileNameVector[i], tmp_Str_Data, &num_Rows_Raw, &num_Columns_Raw);

		vector<vector<double> > tmp_Dbl_Data;//temporary double data for statistical processes

		//convert to double data
		fileRW.Convert_String_2D_To_Double_2D(tmp_Str_Data, tmp_Dbl_Data, num_Row_Skip, num_Col_Skip);

		//sets a category set
		category_Set[0] = cat0[i];
		category_Set[1] = cat1[i];
		category_Set[2] = cat2[i];
		category_Set[3] = cat3[i];
		category_Set[4] = cat4[i];
		category_Set[5] = cat5[i];
		category_Set[6] = cat6[i];

		num_Rows_Data = ((int)tmp_Dbl_Data.size());//the number of rows in the data vector
		num_Columns_Data = ((int)tmp_Dbl_Data[0].size());//the number of columns in the data vector

		//////////////////////////////////////////
		//////////////////////////////////////////
		//data processing unit//
		/////////////////////////////////////////
		//restess the state of meeting the condition
		//int start_Row: the sequence of the row in the data (except headers) for starting to count
		//int end_Row: the sequence of the row n the data (except headers) that the counting ends

		//initialization
		tmp_Min = tmp_Dbl_Data[start_Row][p_Column_Selected];

		for (j = start_Row; j < end_Row; j++)
		{
			if (tmp_Dbl_Data[j][p_Column_Selected] < tmp_Min)
			{
				tmp_Min = tmp_Dbl_Data[j][p_Column_Selected];
			}//end if
		}//end data row loop

		s_Unit.Update_Squared_Sum_Difference(category_Set, &tmp_Min);
	}//end file loop

	//calculates standard deviations
	s_Unit.Set_SD();

	//sets the output file
	string fileName_Output = "mn_" + id_Tag;//output file name
	//writes the results of the counter
	fileName_Output = s_Unit.Write_Output_File(&fileName_Output);

	//de-allocates memory
	s_Unit.De_Allocate_Memory();

	return fileName_Output;
}