#pragma once

#include "Data_Manipulation.h"
#include "File_RW.h"

class Batch_Data_Proc
{
public:
	Batch_Data_Proc();
	~Batch_Data_Proc();

	//calculates product of values and frequencies
	string Batch_Product_Value_Frequency(vector<double> &p_Val, string fileName_Freq, int num_Row_Skip, int num_Col_Skip);

	//calculates means and variance in batch without label
	void Batch_Mean_Var_2D_Value(string fileName_Cat, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);
	//calculates means and variance in batch with label
	void Batch_Mean_Var_2D_Value_Label(string fileName_Cat, int *simul_Label, int *num_Simul_Label, int p_RepNum, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);

	//calculates means and variance of data in multiple identically-arranged files in batch without label
	//Category by column
	void Batch_Multiple_Source_Mean_Var_2D_Value(vector<string> fileName_Cat, int *num_Simul_Label, int p_RepNum, int num_Segments, int num_Row_Skip, int num_Col_Skip);

	//calculates means and variance in batch (value * frequency data) without label; imports category values from a file
	void Batch_Mean_Var_2D_Value_Frequency(string fileName_Val, string fileName_Freq, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);

	//calculates means and variance in batch (value * frequency data) without label; imports category values from vector<double>
	//returns the name of the file containing output data
	string Batch_Mean_Var_2D_Value_Frequency_Raw(vector<double> &p_Val, string fileName_Freq, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);
	//calculates means and variance in batch (value * frequency data) without label; imports category values from vector<double>
	//returns the name of the file containing output data
	//adds a character to the returining file name
	string Batch_Mean_Var_2D_Value_Frequency_Raw_Add_Char(vector<double> &p_Val, string fileName_Freq, string p_Character_To_Add, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);

	//calculates means and variance in batch (value * frequency data) with label
	void Batch_Mean_Var_2D_Value_Frequency_Label(string fileName_Val, string fileName_Freq, int *simul_Label, int *num_Simul_Label, int p_RepNum, int num_Segments, int num_Row_Skip, int num_Col_Skip, int sort_Order);

	//the first order difference
	string Batch_Delta_2D_Value(string fileName_Cat, int num_Row_Skip, int num_Col_Skip, int sort_Order);
	//the second difference
	string Batch_Delta_Delta_2D_Value(string fileName_Cat, int num_Row_Skip, int num_Col_Skip, int sort_Order);

	//interval trimming
	//keeps column lables (on the first few rows)
	string Batch_Trim_2D_String_Data_Interval_Row_Label(string fileName_Cat, int num_Row_Skip, int num_Col_Skip, int p_Row_Interval);
	//interval trimming
	//does not keep column lables (on the first few rows)
	string Batch_Trim_2D_String_Data_Interval(string fileName_Cat, int num_Row_Skip, int num_Col_Skip, int p_Row_Interval);
};

