#pragma once
#include <vector>
#include <string>//for csv file
#include <cmath>
#include "File_RW.h"

using namespace std;

class Counter_Unit
{
private:
	int tot_Num_Combination;//The total number of case combinations
	int num_Category;//the number of categories = 7
	int *******data_True;//counter for a true data set; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	int *******data_Counter;//data counter vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]

	double *******data_Sum_Duration;//data counter vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Mean_Duration;//data counter vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Sum_Squared_Difference_Duration;//data counter vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_SD_Duration;//data counter vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]

	double *******data_Max_Duration;//the maximum vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Min_Duration;//the minimum vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]

	int *tmp_End;//the number of classes for each category
	//the minimum number of classes per category is 1
	//category is integer starting from 0
	//class is integer starting from 0
public:
	Counter_Unit(vector<int> &p_Num_Class);
	~Counter_Unit();

	//Follow the call sequence below
	//1. Loop{ Update_Counter(vector<int> &p_Category_Set, bool *p_State) }
	//2. Write_Output_File(string *fileName_Tag);
	//3. De_Allocate_Memory(void)

	//updates the counter by one for a given category set
	void Update_Counter_Sum_Duration(vector<int> &p_Category_Set, bool *p_State, double *p_Duration);

	//updates the counter by one for a given category set and updates sum of squared differences
	void Update_Counter_Squared_Difference_Duration(vector<int> &p_Category_Set, bool *p_State, double *p_Duration);

	//sets duration means
	void Set_Mean_Duration(void);

	//sets duration standard deviations
	void Set_SD_Duration(void);

	//resets the counter
	void Reset_Counter(void);

	//writes an output file
	string Write_Output_File(string *fileName_Tag);

	//memory deallocation
	void De_Allocate_Memory(void);

	//returns the number of columns for the output file
	void Get_Num_Row_Output_File(int *p_Num_Row_Output, int *p_Num_Row_Header);
};

