#pragma once

#include <iostream>
#include <set>
//#include <map>
#include <iterator>
#include <vector>

using namespace std;

class Data_Manipulation
{
public:
	Data_Manipulation();
	~Data_Manipulation();

	//sorts by double values in 1d array and returns new indeces
	void Sort_Double_One_D(double *p_Reference, int *p_Size_dataSet, int *p_Index_New, int *p_Size_SortedSet);

	//sorts by double values in 1d array and returns new indeces
	void Sort_Double_Two_D(double **p_Reference, int *p_Size_A_dataSet, int *p_Size_B_dataSet, int **p_Index_New, int *p_Size_SortedSet);

	//sorts by double values in 1d array and returns new indeces
	void Sort_Double_Three_D(double ***p_Reference, int *p_Size_A_dataSet, int *p_Size_B_dataSet, int *p_Size_C_dataSet, int ***p_Index_New, int *p_Size_SortedSet);

	//Example in sorting 1D array
	void Example_Sort_Double_One_D(void);
	void Example_Sort_Double_Two_D(void);

	//Computational routine
	void Get_MaxDiff_4D_Mat(double *p_Max, double ****mat0, double ****mat1, int nCls);//finds the maximum difference in 4-D matrix
	void Get_MaxDiff_2D_Mat(double *p_Max, double **mat0, double **mat1, int nCls);//finds the maximum difference in 4-D matrix

	//Resorting data
	void ReArrange_4D_Mat(double ****mat_Rearranged, double ****mat, int nCls, int *s);//Re-arrange 4D matrix in a specific order
	void ReArrange_2D_Mat(double **mat_Rearranged, double **mat, int nCls, int *s);//Re-arrange 4D matrix in a specific order

	void Get_Freq_Dim_4_Discrete(double ****mat, double *p_TotSum, int nc, double **frq);//calculates frequencies of classes in each dimension in 4-dimensional matrix
	void Get_Freq_Dim_2_Discrete(double **mat, double *p_TotSum, int nc, double **frq);//calculates frequencies of classes in each dimension in 4-dimensional matrix

	void Get_Exp_Freq_4D_Discrete(double ****mat_Exp, double *p_TotSum, double ****mat, int nc);//calculates the expected frequency
	void Get_Exp_Freq_2D_Discrete(double **mat_Exp, double *p_TotSum, double **mat, int nc);//calculates the expected frequency

	void Get_Fraction_Dim_4_Discrete(double ****mat, double p_TotSum, int nc);//convert elements into fractions by using the total sum
	void Get_Fraction_Dim_2_Discrete(double **mat, double p_TotSum, int nc);//convert elements into fractions by using the total sum

	void Get_CDF_4D_Discrete(double ****cumul_Map, double ****map, int numCela, int numCelb, int numCelc, int numCeld);//Gets the cumulative 4 dimensional discrete cumulative distribution
	void Get_CDF_2D_Discrete(double **cumul_Map, double **map, int numCela, int numCelb);//Gets the cumulative 2 dimensional discrete cumulative distribution

	void Get_CDF_4D_Discrete_Self(double ****map, int numCela, int numCelb, int numCelc, int numCeld);//Gets the cumulative 4 dimensional discrete cumulative distribution
	void Get_CDF_2D_Discrete_Self(double **map, int numCela, int numCelb);//Gets the cumulative 4 dimensional discrete cumulative distribution

	void Cdf_4D_Observed_Expected(double ****mat, double ****mat_Exp, int numCls, double *num_Observations);//calculates the cumulative probability density for 4-D observed values and their expected values
	void Cdf_2D_Observed_Expected(double **mat, double **mat_Exp, int numCls, double *num_Observations);//calculates the cumulative probability density for 4-D observed values and their expected values

	//Difference calculus
	//returns the first-degree difference of an array
	void Get_Delta(double *p_Delta, double *p_Data, int *p_Num_Ele_Data);
	void Get_2D_Delta(double **p_Delta, double **p_Data, int *p_Num_Rows, int *p_Num_Columns, int sort_Order);

	//returns the second-degree difference of an array
	void Get_Delta_Delta(double *p_Delta_Delta, double *p_Data, int *p_Num_Ele_Data);
	void Get_2D_Delta_Delta(double **p_Delta, double **p_Data, int *p_Num_Rows, int *p_Num_Columns, int sort_Order);

	//Statistics
	//(value * frequency (or abundance)) case
	void Get_Mean_SD_Pop_Value_Freq(double *p_Mean, double *p_Variance, double *p_SD, double *p_Value, double *p_Frequency, int num_Elements);
	//(value * frequency (or abundance)) case for 2D matrix (0: row sorted, 1: column sorted)
	//Category values (p_Value) change
	void Get_Mean_SD_Pop_Value_Freq_2D(double **p_Mean, double **p_Variance, double **p_SD, double **p_Value, double **p_Frequency, int num_Rows, int num_Columns, int num_Sets, int sort_Order);
	//(value * frequency (or abundance)) case for 2D matrix (0: row sorted, 1: column sorted)
	//Category values (p_Value) do not change
	void Get_Mean_SD_Pop_Value_Fixed_Freq_2D(double **p_Mean, double **p_Variance, double **p_SD, double *p_Value, double **p_Frequency, int num_Rows, int num_Columns, int num_Sets, int sort_Order);

	//value  case
	void Get_Mean_SD_Pop_Value(double *p_Mean, double *p_Variance, double *p_SD, double *p_Value, int num_Elements);
	//value  case for 2D matrix (0: row sorted (----), 1: column sorted (|||||))
	void Get_Mean_SD_Pop_Value_2D(double **p_Mean, double **p_Variance, double **p_SD, double **p_Value, int num_Rows, int num_Columns, int num_Sets, int sort_Order);

	//Trim data
	//trims data down by selecting data at an interval 
	void Trim_2D_String_Data_Interval(vector<vector<string>> &tmp_New_Data, vector<vector<string>> &tmp_Data, int num_Row_Skip, int num_Column_Skip, int p_Row_Interval);
	// trims data down by selecting data at an interval
	//keeps row & column label
	void Trim_2D_String_Data_Interval_Keep_Column_Label(vector<vector<string>> &tmp_New_Data, vector<vector<string>> &tmp_Data, int num_Row_Skip, int num_Column_Skip, int p_Row_Interval);

	//finds the minimum & maximum values
};

