/*
* CSVRW.cpp
*
*  Created on: Dec 8, 2014
*      Author: jungk_000
*/

#include "File_RW.h"

File_RW::File_RW() {
	// TODO Auto-generated constructor stub
	//convert.precision(10);
	//convert << std::fixed;
	convertD.precision(15);
}

File_RW::~File_RW() {
	// TODO Auto-generated destructor stub
}

void File_RW::CSV_Write_Add_Integer_2D(char *fileName, int** tmpArr, int *p_num_Row, int *p_num_Col){
	fstream t_fileStream;//file stream
	t_fileStream.open(fileName, fstream::out | fstream::app);//opens a file at the end of the file

	int row, col;
	const int lcol = (*p_num_Col) - 1;//the number of columns - 1

	if (lcol > 0){//multiple columns
		for (row = 0; row < (*p_num_Row); row++){
			for (col = 0; col < lcol; col++){
				t_fileStream << tmpArr[row][col] << ",";//put double to a string stream
			}//end column loop

			t_fileStream << tmpArr[row][lcol] << "\n";//go to the next line
		}//end row loop
	}
	else{//single column
		for (row = 0; row < (*p_num_Row); row++){
			t_fileStream << tmpArr[row][lcol] << "\n";//go to the next line
		}//end row loop
	}//end else

	t_fileStream.close();//file stream close
}

void File_RW::CSV_Write_Add_Double_2D(char *fileName, double** tmpArr, int *p_num_Row, int *p_num_Col){
	ofstream t_fileStream;//file stream
	t_fileStream.open(fileName, ofstream::out | ofstream::app);//opens a file at the end of the file

	int row, col;
	const int lcol = (*p_num_Col) - 1;//the number of columns - 1
	string tmp;
	stringstream conv;//for data type conversion
	conv.precision(15);

	if (lcol > 0){//multiple columns
		for (row = 0; row < (*p_num_Row); row++){
			for (col = 0; col < lcol; col++){
				conv << tmpArr[row][col];
				tmp = conv.str() + ",";
				t_fileStream << tmp;
				conv.str("");
			}//end column loop

			conv << tmpArr[row][lcol];
			tmp = conv.str() + "\n";
			t_fileStream << tmp;
			conv.str("");
		}//end row loop
	}
	else{//single column
		for (row = 0; row < (*p_num_Row); row++){
			conv << tmpArr[row][lcol];
			tmp = conv.str() + "\n";
			t_fileStream << tmp;
			conv.str("");
		}//end row loop
	}//end else

	t_fileStream.close();//file stream close
}
void File_RW::CSV_Write_Add_Double_2D_Vector(char *fileName, vector<vector<double>> tmpArr){
	int p_Num_Row = (int)tmpArr.size();
	int p_Num_Col = (int)tmpArr[0].size();

	ofstream t_fileStream;//file stream
	t_fileStream.open(fileName, ofstream::out | ofstream::app);//opens a file at the end of the file

	int row, col;
	const int lcol = p_Num_Col - 1;//the number of columns - 1
	string tmp;
	stringstream conv;//for data type conversion
	conv.precision(15);

	if (lcol > 0){//multiple columns
		for (row = 0; row < p_Num_Row; row++){
			for (col = 0; col < lcol; col++){
				conv << tmpArr[row][col];
				tmp = conv.str() + ",";
				t_fileStream << tmp;
				conv.str("");
			}//end column loop

			conv << tmpArr[row][lcol];
			tmp = conv.str() + "\n";
			t_fileStream << tmp;
			conv.str("");
		}//end row loop
	}
	else{//single column
		for (row = 0; row < p_Num_Row; row++){
			conv << tmpArr[row][lcol];
			tmp = conv.str() + "\n";
			t_fileStream << tmp;
			conv.str("");
		}//end row loop
	}//end else

	t_fileStream.close();//file stream close
}

void File_RW::CSV_Create(char *fileName)
{
	fstream t_fileStream;//file stream
	t_fileStream.open(fileName, fstream::out);
	t_fileStream.close();//file stream close
}

void File_RW::CSV_Read_String_2D(char *fileName, vector<vector<string> > &tmpArr, int *p_num_Row, int *p_num_Col)
{
	//fileName: file name
	//tmpArr: multi-dimensional vector for gettting information
	//p_num_Row: the number of rows in the file
	//p_num_Col: the maximum number of columns in the file

	fstream t_fileStream;//file stream
	t_fileStream.open(fileName, fstream::in);//opens a file at the end of the file
	int comma_pos, length_line;//the position of comma(,)
	int max_num_Columns = 0;//the maximum number of columns 
	string tmpString;

	if (!t_fileStream.fail()){
		vector<string> tmp;

		while (!t_fileStream.eof()){
			//New row
			string line;
			getline(t_fileStream, line);//reads a line
			length_line = (int)line.length();
			comma_pos = (int)line.find_first_of(',');

			if (comma_pos > 0){//multiple columns
				while (comma_pos > 0)
				{//column loop
					tmpString = line.substr(0, comma_pos);//reads a data point
					tmp.push_back(tmpString);//adds a data point
					line.erase(0, (comma_pos + 1));//erase the already-read data
					comma_pos = (int)line.find_first_of(',');//locates the next comma position
				}//end column loop

				tmp.push_back(line);//adds the last element in a given row to the data
				tmpArr.push_back(tmp);//adds a given row to data
				tmp.clear();
			}
			else if (length_line > 0)
			{//single column
				tmp.push_back(line);//adds the last element in a given row to the data
				tmpArr.push_back(tmp);//adds a given row to data
				tmp.clear();
			}
			else
			{//no columns

			}//else
		}//end row while loop
	}//end if

	//sets the number of rows
	(*p_num_Row) = (int)tmpArr.size();

	//get the maximum number of columns
	if ((*p_num_Row) > 0)
	{
		int i, tmp_Size;
		int end_0 = (*p_num_Row);

		for (i = 0; i < end_0; i++)
		{
			tmp_Size = (int)tmpArr[i].size();

			if (tmp_Size > max_num_Columns)
			{
				max_num_Columns = tmp_Size;
			}//end if
		}//end row loop
	}//end if

	// sets the number of columns
	(*p_num_Col) = max_num_Columns;

	t_fileStream.close();//closes the file stream
}

void File_RW::CSV_Read_String_2D_String(string fileName, vector<vector<string> > &tmpArr, int *p_num_Row, int *p_num_Col)
{
	//fileName: file name
	//tmpArr: multi-dimensional vector for gettting information
	//p_num_Row: the number of rows in the file
	//p_num_Col: the maximum number of columns in the file
	int size_String = (int)fileName.length();
	char *fileName_Char = new char[(size_String + 1)];//one more cell for ending character array	

	//converts string to character array
	Copy_String_To_Char_Arr(fileName, fileName_Char);//copy string and paste on char* 

	//reads a 2-D array from a file
	CSV_Read_String_2D(fileName_Char, tmpArr, p_num_Row, p_num_Col);

	delete[] fileName_Char;
}

void File_RW::CSV_Write_Add_String_2D(char *fileName, string** tmpArr, int *p_num_Row, int *p_num_Col)
{
	fstream t_fileStream;//file stream
	t_fileStream.open(fileName, fstream::out | fstream::app);//opens a file at the end of the file

	int row, col;
	const int lcol = (*p_num_Col) - 1;//the number of columns - 1
	string tmp;

	if (lcol > 0){//multiple columns
		for (row = 0; row < (*p_num_Row); row++){
			for (col = 0; col < lcol; col++){
				t_fileStream << tmpArr[row][col];//adds a data to the file stream
				t_fileStream << ",";//adds a separator
			}//end column loop

			t_fileStream << tmpArr[row][lcol];//adds a data to the file stream
			t_fileStream << "\n";
		}//end row loop
	}
	else{//single column
		for (row = 0; row < (*p_num_Row); row++){
			t_fileStream << tmpArr[row][lcol];//adds a data to the file stream
			t_fileStream << "\n";
		}//end row loop
	}//end else

	t_fileStream.close();//file stream close
}

void File_RW::CSV_Write_Add_String_2D_Vector(char *fileName, vector<vector<string>> &tmpArr)
{
	fstream t_fileStream;//file stream
	t_fileStream.open(fileName, fstream::out | fstream::app);//opens a file at the end of the file

	int p_num_Row = (int)tmpArr.size();
	int p_num_Col = (int)tmpArr[0].size();

	int row, col;
	const int lcol = p_num_Col - 1;//the number of columns - 1
	string tmp;

	if (lcol > 0){//multiple columns
		for (row = 0; row < p_num_Row; row++){
			for (col = 0; col < lcol; col++){
				t_fileStream << tmpArr[row][col];//adds a data to the file stream
				t_fileStream << ",";//adds a separator
			}//end column loop

			t_fileStream << tmpArr[row][lcol];//adds a data to the file stream
			t_fileStream << "\n";
		}//end row loop
	}
	else{//single column
		for (row = 0; row < p_num_Row; row++){
			t_fileStream << tmpArr[row][lcol];//adds a data to the file stream
			t_fileStream << "\n";
		}//end row loop
	}//end else

	t_fileStream.close();//file stream close
}

void File_RW::Copy_String_To_Char_Arr(string tmpS, char *tmpC)
{
	//the number of cells in tmpC should be (the length of string + 1)
	int size_String = (int)tmpS.length();

	int i;
	//copy characters
	for (i = 0; i < size_String; i++){
		tmpC[i] = tmpS.at(i);
	}//end i loop

	tmpC[size_String] = '\0';//very important step for ending character array
}

void File_RW::CSV_Create_String(string tmpS)
{
	//the number of cells in tmpC should be (the length of string + 1)
	int size_String = (int)tmpS.length();
	char *tmpC = new char[(size_String + 1)];

	int i;
	//copy characters
	for (i = 0; i < size_String; i++){
		tmpC[i] = tmpS.at(i);
	}//end i loop

	tmpC[size_String] = '\0';//very important step for ending character array

	CSV_Create(tmpC);//create a new file

	delete[] tmpC;
}

void File_RW::Integer_To_String(string *p_Str, int *p_Tmp)
{
	convert.str("");//initialization
	convert << (*p_Tmp);//for data type conversion
	(*p_Str) = convert.str();//sets the simulation counter string
	convert.str("");//initialization
}

void File_RW::Double_To_String(string *p_Str, double *p_Temp)
{
	convertD.str("");//initialization
	convertD.precision(15);
	convertD << (*p_Temp);
	(*p_Str) = convertD.str();
	convertD.str("");//initialization
}

void File_RW::UInteger32_To_String(string *p_Str, uint32_t *p_Tmp)
{
	convert << (*p_Tmp);//for data type conversion
	(*p_Str) = convert.str();//sets the simulation counter string
	convert.str("");//initialization
}

void File_RW::CSV_Write_Add_Double_1DD(char *fileName, double* tmpArr, int *p_num_0)
{
	int i, cnt;
	int num_Col = 2;
	int num_Row = (*p_num_0);
	//sets a temporary container
	double **tmpA = new double*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new double[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < num_Row; i++){
		tmpA[cnt][0] = (double)i;
		tmpA[cnt][1] = tmpArr[i];
		cnt++;
	}//end i loop

	//writes data on file
	CSV_Write_Add_Double_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Double_2DD(char *fileName, double** tmpArr, int *p_num_0, int *p_num_1)
{

	int i, j, cnt;
	int num_Col = 3;
	int num_Row = (*p_num_0) * (*p_num_1);
	//sets a temporary container
	double **tmpA = new double*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new double[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			tmpA[cnt][0] = (double)i;
			tmpA[cnt][1] = (double)j;
			tmpA[cnt][2] = tmpArr[i][j];
			cnt++;
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Double_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Double_3DD(char *fileName, double*** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2)
{

	int i, j, k, cnt;
	int num_Col = 4;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2);
	//sets a temporary container
	double **tmpA = new double*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new double[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				tmpA[cnt][0] = (double)i;
				tmpA[cnt][1] = (double)j;
				tmpA[cnt][2] = (double)k;
				tmpA[cnt][3] = tmpArr[i][j][k];
				cnt++;
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Double_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Double_4DD(char *fileName, double**** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3)
{

	int i, j, k, l, cnt;
	int num_Col = 5;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2) * (*p_num_3);
	//sets a temporary container
	double **tmpA = new double*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new double[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				for (l = 0; l < (*p_num_3); l++){
					tmpA[cnt][0] = (double)i;
					tmpA[cnt][1] = (double)j;
					tmpA[cnt][2] = (double)k;
					tmpA[cnt][3] = (double)l;
					tmpA[cnt][4] = tmpArr[i][j][k][l];
					cnt++;
				}//end l loop
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Double_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Double_5DD(char *fileName, double***** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3, int *p_num_4)
{
	int i, j, k, l, m, cnt;
	int num_Col = 6;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2) * (*p_num_3) * (*p_num_4);
	//sets a temporary container
	double **tmpA = new double*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new double[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				for (l = 0; l < (*p_num_3); l++){
					for (m = 0; m < (*p_num_4); m++){
						tmpA[cnt][0] = (double)i;
						tmpA[cnt][1] = (double)j;
						tmpA[cnt][2] = (double)k;
						tmpA[cnt][3] = (double)l;
						tmpA[cnt][4] = (double)m;
						tmpA[cnt][5] = tmpArr[i][j][k][l][m];
						cnt++;
					}//end m loop
				}//end l loop
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Double_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Integer_1DD(char *fileName, int* tmpArr, int *p_num_0)
{
	int i, cnt;
	int num_Col = 2;
	int num_Row = (*p_num_0);
	//sets a temporary container
	int **tmpA = new int*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new int[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < num_Row; i++){
		tmpA[cnt][0] = i;
		tmpA[cnt][1] = tmpArr[i];
		cnt++;
	}//end i loop

	//writes data on file
	CSV_Write_Add_Integer_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Integer_2DD(char *fileName, int** tmpArr, int *p_num_0, int *p_num_1)
{

	int i, j, cnt;
	int num_Col = 3;
	int num_Row = (*p_num_0) * (*p_num_1);
	//sets a temporary container
	int **tmpA = new int*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new int[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			tmpA[cnt][0] = i;
			tmpA[cnt][1] = j;
			tmpA[cnt][2] = tmpArr[i][j];
			cnt++;
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Integer_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Integer_3DD(char *fileName, int*** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2)
{

	int i, j, k, cnt;
	int num_Col = 4;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2);
	//sets a temporary container
	int **tmpA = new int*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new int[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				tmpA[cnt][0] = i;
				tmpA[cnt][1] = j;
				tmpA[cnt][2] = k;
				tmpA[cnt][3] = tmpArr[i][j][k];
				cnt++;
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Integer_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Integer_4DD(char *fileName, int**** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3)
{

	int i, j, k, l, cnt;
	int num_Col = 5;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2) * (*p_num_3);
	//sets a temporary container
	int **tmpA = new int*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new int[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				for (l = 0; l < (*p_num_3); l++){
					tmpA[cnt][0] = i;
					tmpA[cnt][1] = j;
					tmpA[cnt][2] = k;
					tmpA[cnt][3] = l;
					tmpA[cnt][4] = tmpArr[i][j][k][l];
					cnt++;
				}//end l loop
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Integer_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::CSV_Write_Add_Integer_5DD(char *fileName, int***** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3, int *p_num_4)
{
	int i, j, k, l, m, cnt;
	int num_Col = 6;
	int num_Row = (*p_num_0) * (*p_num_1) * (*p_num_2) * (*p_num_3) * (*p_num_4);
	//sets a temporary container
	int **tmpA = new int*[num_Row];

	for (i = 0; i < num_Row; i++){
		tmpA[i] = new int[num_Col];
	}//end i loop

	cnt = 0;//resets counter

	for (i = 0; i < (*p_num_0); i++){
		for (j = 0; j < (*p_num_1); j++){
			for (k = 0; k < (*p_num_2); k++){
				for (l = 0; l < (*p_num_3); l++){
					for (m = 0; m < (*p_num_4); m++){
						tmpA[cnt][0] = i;
						tmpA[cnt][1] = j;
						tmpA[cnt][2] = k;
						tmpA[cnt][3] = l;
						tmpA[cnt][4] = m;
						tmpA[cnt][5] = tmpArr[i][j][k][l][m];
						cnt++;
					}//end m loop
				}//end l loop
			}//end k loop
		}//end j loop
	}//end i loop

	//writes data on file
	CSV_Write_Add_Integer_2D(fileName, tmpA, &num_Row, &num_Col);

	for (i = 0; i < num_Row; i++){
		delete[] tmpA[i];
	}//end i loop

	delete[] tmpA;
}

void File_RW::Get_Simul_Label(string *tmp_Str_0, int *simul_Label, int *num_Simul_Label, int p_RepNum)
{
	//string tmp_Str_0: label for simulation
	//int *simul_Label: array storing simulation settings
	//int *num_Simul_Label:the number of settings
	//int p_RepNum: replicate number
	int i;

	(*tmp_Str_0) = "_";

	for (i = 0; i < (*num_Simul_Label); i++)
	{
		(*tmp_Str_0) += std::to_string((simul_Label[i])) + "_";
	}//end 

	(*tmp_Str_0) += std::to_string((p_RepNum));
}

void File_RW::Convert_String_2D_To_Double_2D(vector<vector<string> > &tmpStr, vector<vector<double> > &tmpDbl, int num_Header_Rows, int num_Header_Columns)
{
	//tmpStr: 2-D string vector with double data and row & column headers
	//tmpDbl: 2-D double vector without size (create a new multi-dimensional vector for each use of this function)
	//num_Header_Rows: the number of header rows to skip (if there is no row header, num_Header_Rows = 0)
	//num_Header_Columns: the number of header columns to skip (if the is no column header, num_Header_Columns = 0)
	int i, j;
	int end_Row = ((int)tmpStr.size());//the number of rows
	int end_Column = ((int)tmpStr[0].size());//the number of columns
	///std::string::size_type sz;//alias of size_t	
	tmpDbl.resize((end_Row - num_Header_Rows), vector<double>((end_Column - num_Header_Columns)));

	for (i = num_Header_Rows; i < end_Row; i++)
	{
		for (j = num_Header_Columns; j < end_Column; j++)
		{
			//converts string to double
			tmpDbl[(i - num_Header_Rows)][(j - num_Header_Columns)] = std::stod(tmpStr[i][j]);
		}//end column loop
	}//end row loop
}

void File_RW::String_To_Double(double *p_Dbl, string *p_Str)
{
	(*p_Dbl) = std::stod((*p_Str));
}

void File_RW::String_To_Integer(int *p_Int, string *p_Str)
{
	(*p_Int) = std::stoi((*p_Str));
}

void File_RW::CSV_Add_CSV_To_CSV(string fileName_Target, string fileName_Source)
{
	//read string data from a source
	//temporary string container
	vector<vector<string>> tmpStr;
	int num_Row, num_Col;
	CSV_Read_String_2D_String(fileName_Source, tmpStr, &num_Row, &num_Col);

	//target file name
	int tmp_Size = ((int)fileName_Target.length()) + 1;
	char *fileName_Target_Char = new char[tmp_Size];
	Copy_String_To_Char_Arr(fileName_Target, fileName_Target_Char);

	//add string data to a target
	CSV_Write_Add_String_2D_Vector(fileName_Target_Char, tmpStr);

	delete[] fileName_Target_Char;
}

void File_RW::CSV_Add_Column_Integer(string fileName, int tmp_Int)
{
	//temporary string container
	vector<vector<string>> tmpStr;
	int num_Row, num_Col;
	//read string data from a source
	CSV_Read_String_2D_String(fileName, tmpStr, &num_Row, &num_Col);

	//the number of new columns
	int num_Col_New = num_Col + 1;

	//create a temporary 2D string
	string **tmp_Str = new string*[num_Row];

	for (int i = 0; i < num_Row; i++)
	{
		tmp_Str[i] = new string[num_Col_New];
	}//end row loop

	//add a new integer column (the first column)
	string tmp_Inte_Str;
	//convert integer to string
	Integer_To_String(&tmp_Inte_Str, &tmp_Int);

	for (int i = 0; i < num_Row; i++)
	{
		for (int j = 0; j < num_Col_New; j++)
		{
			if (j == 0)
			{
				tmp_Str[i][j] = tmp_Inte_Str;
			}
			else
			{
				tmp_Str[i][j] = tmpStr[i][(j-1)];
			}//end else
		}//end column loop
	}//end row loop

	//delete the previous data content
	CSV_Create_String(fileName);//create a new file with string

	//target file name
	int tmp_size = ((int)fileName.length()) + 1;
	char *fileName_Char = new char[tmp_size];
	Copy_String_To_Char_Arr(fileName, fileName_Char);

	//add new data
	CSV_Write_Add_String_2D(fileName_Char, tmp_Str, &num_Row, &num_Col_New);
	
	//deallocate memory
	delete[] fileName_Char;

	//deallocate memory
	for (int i = 0; i < num_Row; i++)
	{
		delete[] tmp_Str[i];
	}//end row loop

	delete[] tmp_Str;
}