/*
* CSVRW.h
*
*  Created on: Dec 8, 2014
*      Author: jungk_000
*/
#ifndef FILERW_H_
#define FILERW_H_

#include <string>
#include <iostream>
#include <iomanip>
#include <limits>
#include <boost/random/mersenne_twister.hpp>
#include <fstream>//for csv file
#include <sstream>//for csv file
#include <vector>

using namespace std;

class File_RW {
private:
	stringstream convert;//for data type conversion
	stringstream convertD;//for data type conversion
public:
	File_RW();
	virtual ~File_RW();
	//fstream csvFile;/file stream
	//csvFile.open("test.csv", fstream::out);//creates and opens a file
	//csvFile.open("test.csv", fstream::out);//creates and opens a file
	//csvFile.open("test.csv", fstream::ate);//opens a file at the end of the file
	//csvFile.open("test.csv", fstream::app);//opens a file at the end of the file, and appends the data to the last cell
	//csvFile.open("test.csv", fstream::trunc);//removes the contents and opens a file
	void CSV_Create(char *fileName);//create a new file with char*
	void CSV_Create_String(string tmps);//create a new file with string

	//add a csv file to other csv file
	void CSV_Add_CSV_To_CSV(string fileName_Target, string fileName_Source);

	//add an integer column to a csv file
	void CSV_Add_Column_Integer(string fileName, int tmp_Int);

	//add data to an existing file.
	void CSV_Write_Add_Integer_2D(char *fileName, int** tmpArr, int *p_num_Row, int *p_num_Col);
	void CSV_Write_Add_Double_2D(char *fileName, double** tmpArr, int *p_num_Row, int *p_num_Col);
	void CSV_Write_Add_Double_2D_Vector(char *fileName, vector<vector<double>> tmpArr);

	//adds data array to a file
	void CSV_Write_Add_Integer_1DD(char *fileName, int* tmpArr, int *p_num_0);
	void CSV_Write_Add_Integer_2DD(char *fileName, int** tmpArr, int *p_num_0, int *p_num_1);
	void CSV_Write_Add_Integer_3DD(char *fileName, int*** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2);
	void CSV_Write_Add_Integer_4DD(char *fileName, int**** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3);
	void CSV_Write_Add_Integer_5DD(char *fileName, int***** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3, int *p_num_4);

	void CSV_Write_Add_Double_1DD(char *fileName, double* tmpArr, int *p_num_0);
	void CSV_Write_Add_Double_2DD(char *fileName, double** tmpArr, int *p_num_0, int *p_num_1);
	void CSV_Write_Add_Double_3DD(char *fileName, double*** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2);
	void CSV_Write_Add_Double_4DD(char *fileName, double**** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3);
	void CSV_Write_Add_Double_5DD(char *fileName, double***** tmpArr, int *p_num_0, int *p_num_1, int *p_num_2, int *p_num_3, int *p_num_4);

	//writes 2-D string array on a file
	void CSV_Write_Add_String_2D(char *fileName, string** tmpArr, int *p_num_Row, int *p_num_Col);
	//writes 2-D string vector on a file
	void CSV_Write_Add_String_2D_Vector(char *fileName, vector<vector<string>> &tmpArr);

	//reads data from a file with character name array
	void CSV_Read_String_2D(char *fileName, vector<vector<string> > &tmpArr, int *p_num_Row, int *p_num_Col);
	//reads data from a file with string name
	void CSV_Read_String_2D_String(string fileName, vector<vector<string> > &tmpArr, int *p_num_Row, int *p_num_Col);

	//Convert string type to char*
	void Copy_String_To_Char_Arr(string tmpS, char *tmpC);
	//Convert integer type to string
	void Integer_To_String(string *p_Str, int *p_Tmp);
	void UInteger32_To_String(string *p_Str, uint32_t *p_Tmp);
	//Convert string to double
	void String_To_Double(double *p_Dbl, string*p_Str);
	//Convert string to integer
	void String_To_Integer(int *p_Int, string*p_Str);
	//Convert double type to string
	void Double_To_String(string *p_Str, double *p_Tmp);

	//2-D String to 2-D Double
	void Convert_String_2D_To_Double_2D(vector<vector<string> > &tmpStr, vector<vector<double> > &tmpDbl, int num_Header_Rows, int num_Header_Columns);

	//sets a label for file outputs
	void Get_Simul_Label(string *tmp_Str_0, int *simul_Label, int *num_Simul_Label, int p_RepNum);
};

#endif /* FILERW_H_ */
