#include "Matrix_Population_Model.h"


Matrix_Population_Model::Matrix_Population_Model(int p_Num_Deme, int p_Num_Niche, int p_Num_Spc, int p_Num_Sex, int** p_Num_Stg, string p_Label)
{
	int deme, niche, spc, sex, row, col, i;
	File_RW fileRW;
	string tmp_Str = "mp" + p_Label + ".csv";
	int size_String = (int)tmp_Str.length();
	fileName_Output = new char[(size_String + 1)];//one more cell for ending character array	
	//the number of cells in char* should be (the length of string + 1)
	fileRW.Copy_String_To_Char_Arr(tmp_Str, fileName_Output);//copy string and paste on char*

	num_Deme = p_Num_Deme;
	num_Niche = p_Num_Niche;
	num_Spc = p_Num_Spc;
	num_Sex = p_Num_Sex;
	num_Stg = new int*[num_Spc];

	for (i = 0; i < num_Spc; i++){
		num_Stg[i] = new int[num_Sex];
	}//end species loop

	maxStg = p_Num_Stg[0][0];

	for (i = 0; i < num_Spc; i++){
		for (row = 0; row < num_Sex; row++){
			num_Stg[i][row] = p_Num_Stg[i][row];

			if (num_Stg[i][row] > maxStg){
				maxStg = num_Stg[i][row];
			}//end if
		}//end sex loop
	}//end species loop

	transitionMat = new double*****[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		transitionMat[deme] = new double****[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			transitionMat[deme][niche] = new double***[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				transitionMat[deme][niche][spc] = new double**[num_Sex];

				for (sex = 0; sex < num_Sex; sex++){
					transitionMat[deme][niche][spc][sex] = new double*[maxStg];

					for (row = 0; row < maxStg; row++){
						transitionMat[deme][niche][spc][sex][row] = new double[maxStg];

						for (col = 0; col < maxStg; col++){
							transitionMat[deme][niche][spc][sex][row][col] = 0.0;
						}//end column loop 
					}//end row loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop

	fundMat = new double*****[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		fundMat[deme] = new double****[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			fundMat[deme][niche] = new double***[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				fundMat[deme][niche][spc] = new double**[num_Sex];

				for (sex = 0; sex < num_Sex; sex++){
					fundMat[deme][niche][spc][sex] = new double*[maxStg];

					for (row = 0; row < maxStg; row++){
						fundMat[deme][niche][spc][sex][row] = new double[maxStg];

						for (col = 0; col < maxStg; col++){
							fundMat[deme][niche][spc][sex][row][col] = 0.0;
						}//end column loop 
					}//end row loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop

	var_FundMat = new double*****[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		var_FundMat[deme] = new double****[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			var_FundMat[deme][niche] = new double***[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				var_FundMat[deme][niche][spc] = new double**[num_Sex];

				for (sex = 0; sex < num_Sex; sex++){
					var_FundMat[deme][niche][spc][sex] = new double*[maxStg];

					for (row = 0; row < maxStg; row++){
						var_FundMat[deme][niche][spc][sex][row] = new double[maxStg];

						for (col = 0; col < maxStg; col++){
							var_FundMat[deme][niche][spc][sex][row][col] = 0.0;
						}//end column loop 
					}//end row loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop

	stableStageDist = new double***[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		stableStageDist[deme] = new double**[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			stableStageDist[deme][niche] = new double*[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				stableStageDist[deme][niche][spc] = new double[maxStg];

				for (row = 0; row < maxStg; row++){
					stableStageDist[deme][niche][spc][row] = 0.0;
				}//end row loop
			}//end species loop
		}//end niche loop
	}//end deme loop

	lamda_Pop = new double**[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		lamda_Pop[deme] = new double*[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			lamda_Pop[deme][niche] = new double[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				lamda_Pop[deme][niche][spc] = 0.0;
			}//end species loop
		}//end niche loop
	}//end deme loop

	dds_Pop = new double**[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		dds_Pop[deme] = new double*[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			dds_Pop[deme][niche] = new double[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				dds_Pop[deme][niche][spc] = 0.0;
			}//end species loop
		}//end niche loop
	}//end deme loop

	lifeExpectancy_Mean = new double****[num_Deme];

	for (deme = 0; deme < num_Deme; deme++){
		lifeExpectancy_Mean[deme] = new double***[num_Niche];

		for (niche = 0; niche < num_Niche; niche++){
			lifeExpectancy_Mean[deme][niche] = new double**[num_Spc];

			for (spc = 0; spc < num_Spc; spc++){
				lifeExpectancy_Mean[deme][niche][spc] = new double*[num_Sex];

				for (sex = 0; sex < num_Sex; sex++){
					lifeExpectancy_Mean[deme][niche][spc][sex] = new double[maxStg];

					for (row = 0; row < maxStg; row++){
						lifeExpectancy_Mean[deme][niche][spc][sex][row] = 0.0;
					}//end row loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop
}


Matrix_Population_Model::~Matrix_Population_Model()
{
	int deme, niche, spc, sex, row;

	delete[] fileName_Output;

	for (row = 0; row < num_Spc; row++){
		delete[] num_Stg[row];
	}//end species loop

	delete[] num_Stg;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					for (row = 0; row < maxStg; row++){
						delete[] transitionMat[deme][niche][spc][sex][row];
					}//end row loop

					delete[] transitionMat[deme][niche][spc][sex];
				}//end sex loop

				delete[] transitionMat[deme][niche][spc];
			}//end species loop

			delete[] transitionMat[deme][niche];
		}//end niche loop

		delete[] transitionMat[deme];
	}//end deme loop

	delete[] transitionMat;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					for (row = 0; row < maxStg; row++){
						delete[] fundMat[deme][niche][spc][sex][row];
					}//end row loop

					delete[] fundMat[deme][niche][spc][sex];
				}//end sex loop

				delete[] fundMat[deme][niche][spc];
			}//end species loop

			delete[] fundMat[deme][niche];
		}//end niche loop

		delete[] fundMat[deme];
	}//end deme loop

	delete[] fundMat;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					for (row = 0; row < maxStg; row++){
						delete[] var_FundMat[deme][niche][spc][sex][row];
					}//end row loop

					delete[] var_FundMat[deme][niche][spc][sex];
				}//end sex loop

				delete[] var_FundMat[deme][niche][spc];
			}//end species loop

			delete[] var_FundMat[deme][niche];
		}//end niche loop

		delete[] var_FundMat[deme];
	}//end deme loop

	delete[] var_FundMat;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				delete[] stableStageDist[deme][niche][spc];
			}//end species loop

			delete[] stableStageDist[deme][niche];
		}//end niche loop

		delete[] stableStageDist[deme];
	}//end deme loop

	delete[] stableStageDist;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			delete[] lamda_Pop[deme][niche];
		}//end niche loop

		delete[] lamda_Pop[deme];
	}//end deme loop

	delete[] lamda_Pop;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			delete[] dds_Pop[deme][niche];
		}//end niche loop

		delete[] dds_Pop[deme];
	}//end deme loop

	delete[] dds_Pop;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					delete[] lifeExpectancy_Mean[deme][niche][spc][sex];
				}//end sex loop

				delete[] lifeExpectancy_Mean[deme][niche][spc];
			}//end species loop

			delete[] lifeExpectancy_Mean[deme][niche];
		}//end niche loop

		delete[] lifeExpectancy_Mean[deme];
	}//end deme loop

	delete[] lifeExpectancy_Mean;
}

void Matrix_Population_Model::Set_Vital_Rat(double***** P, double***** G, double**** F)
{
	int deme, niche, spc, sex, row, col, tmp_Stg;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					tmp_Stg = num_Stg[spc][sex];

					for (row = 0; row < tmp_Stg; row++){
						for (col = 0; col < tmp_Stg; col++){
							if (row == col)
							{//P
								transitionMat[deme][niche][spc][sex][row][col] = P[deme][niche][spc][sex][col];
							}
							else if (row == (col + 1))
							{//G
								transitionMat[deme][niche][spc][sex][row][col] = G[deme][niche][spc][sex][col];
							}
							else if ((row == 0) && (sex == 1))
							{//F
								transitionMat[deme][niche][spc][sex][row][col] = F[deme][niche][spc][col];
							}
							else
							{
							}//end else
						}//end column loop 
					}//end row loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop
}

void Matrix_Population_Model::Set_Lamda(double *p_Lamda, double *p_StbDist, int p_Deme, int p_Niche, int p_Spc, int p_Sex)
{
	//*p_Lamda: intrinsic population growth rate
	//*p_StbDist:dim[life stages] stable stage distribution
	int row, col;
	int tmp_Stg = num_Stg[p_Spc][p_Sex];

	//sets a matrix
	MatrixXd transMat(tmp_Stg, tmp_Stg);

	for (row = 0; row < tmp_Stg; row++){
		for (col = 0; col < tmp_Stg; col++){
			transMat(row, col) = transitionMat[p_Deme][p_Niche][p_Spc][p_Sex][row][col];
		}//end column loop
	}//end row loop

	//Calculates eigen values
	EigenSolver<MatrixXd> eigensolver(transMat);

	//gets eigen values
	complex<double> lambda = eigensolver.eigenvalues()[0];
	double major_EigenValue = lambda.real();
	int column_Major = 0;//the column for the major eigenvalue
	double tmp;

	if (tmp_Stg > 1)
	{
		for (row = 1; row < tmp_Stg; row++){
			complex<double> lambda_0 = eigensolver.eigenvalues()[row];
			tmp = lambda_0.real();

			if (tmp > major_EigenValue)
			{
				major_EigenValue = tmp;
				column_Major = row;
			}//end if
		}//end row loop
	}//end if

	//sets the major eigen value
	(*p_Lamda) = major_EigenValue;

	//major eigenvector
	VectorXcd eigen_v = eigensolver.eigenvectors().col(column_Major);

	//sets the stable stage distribution
	double tmp_Sum = 0.0;

	for (row = 0; row < tmp_Stg; row++){
		p_StbDist[row] = eigen_v(row).real();
		tmp_Sum += p_StbDist[row];
	}//end column loop

	//Normalize the proportion of individuals at each life stage
	for (row = 0; row < tmp_Stg; row++){
		p_StbDist[row] /= tmp_Sum;
		//cout << "stg: " << row << ": " << p_StbDist[row] << "\n";
	}//end column loop
}

void Matrix_Population_Model::Set_Stable_DDS(double *p_DDS, int p_Deme, int p_Niche, int p_Spc, int p_Sex)
{
	//*p_Lamda: intrinsic population growth rate
	//*p_StbDist:dim[life stages] stable stage distribution
	int row, col;
	int tmp_Stg = num_Stg[p_Spc][p_Sex];

	//sets a matrix
	MatrixXd transMat(tmp_Stg, tmp_Stg);

	for (row = 0; row < tmp_Stg; row++){
		for (col = 0; col < tmp_Stg; col++){
			transMat(row, col) = transitionMat[p_Deme][p_Niche][p_Spc][p_Sex][row][col];
		}//end column loop
	}//end row loop

	int limit_Iteration = 1000;//the limit of iteration
	double tmp_DDS = 1.0;//temporary density-dependent-survival rate
	double diff = 1.0;//difference of 1 and lambda
	double tolerance_Lambda = 0.001;
	int i;
	double major_EigenValue, tmp;

	//numerically finds density-dependent-survival rate making lambda approximately 1
	//assumes that the density only affects survival and growth rates
	for (i = 0; i < limit_Iteration; i++){

		//sets a transition matrix
		for (row = 0; row < tmp_Stg; row++){
			for (col = 0; col < tmp_Stg; col++){
				if (row >= col)
				{
					transMat(row, col) = transitionMat[p_Deme][p_Niche][p_Spc][p_Sex][row][col] * tmp_DDS;
				}//end if
			}//end column loop
		}//end row loop

		//Calculates eigen values
		EigenSolver<MatrixXd> eigensolver(transMat);

		//gets eigen values
		complex<double> lambda = eigensolver.eigenvalues()[0];
		major_EigenValue = lambda.real();
		(*p_DDS) = (-1.0);

		if (tmp_Stg > 1)
		{
			for (row = 1; row < tmp_Stg; row++){
				complex<double> lambda_0 = eigensolver.eigenvalues()[row];
				tmp = lambda_0.real();

				if (tmp > major_EigenValue)
				{
					major_EigenValue = tmp;
				}//end if
			}//end row loop
		}//end if

		diff = major_EigenValue - 1.0;//population increase rate

		if ((diff < tolerance_Lambda) && (diff >= 0.0)){
			(*p_DDS) = tmp_DDS;
			break;
		}
		else if (diff < 0.0)
		{
			tmp_DDS *= 1.25;
		}
		else
		{
			tmp_DDS *= 0.5;
		}//end else
	}//end i loop
}

void Matrix_Population_Model::Set_Lamda_Pop(void)
{
	//for females
	int deme, niche, spc, stg, tmp_Stg;
	int sex = 1;
	double *tmp_StableStageDistribution = new double[maxStg];//stable stage distribution

	//initialization
	for (stg = 0; stg < maxStg; stg++){
		tmp_StableStageDistribution[stg] = 0.0;
	}//end life stage loop

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				tmp_Stg = num_Stg[spc][sex];
				Set_Lamda(&lamda_Pop[deme][niche][spc], tmp_StableStageDistribution, deme, niche, spc, sex);//returns the population growth rate (for female)

				for (stg = 0; stg < tmp_Stg; stg++){
					stableStageDist[deme][niche][spc][stg] = tmp_StableStageDistribution[stg];
				}//end life stage loop

				//sets density-dependent-survival & growth rates stabilizes the population growth
				Set_Stable_DDS(&dds_Pop[deme][niche][spc], deme, niche, spc, sex);
			}//end species loop
		}//end niche loop
	}//end deme loop

	delete[] tmp_StableStageDistribution;
}

void Matrix_Population_Model::Run_Analysis(void)
{
	//calculates population growth rate and stable stage distribution
	Set_Lamda_Pop();
	//calculates age-related characteristics
	Set_AgeChar();
	//sets output
	Set_Output();
}

void Matrix_Population_Model::Set_FundMat(double **p_FundMat, double **p_Var_FundMat, double *p_LifeExp, int p_Deme, int p_Niche, int p_Spc, int p_Sex)
{
	//*p_LifeExp:dim[life stages]; The mean time to death given that an individual starts in life stage j
	int row, col;
	int tmp_Stg = num_Stg[p_Spc][p_Sex];

	//sets a transition matrix
	MatrixXd transMat(tmp_Stg, tmp_Stg);

	for (row = 0; row < tmp_Stg; row++){
		for (col = 0; col < tmp_Stg; col++){
			if (row > col)
			{
				transMat(row, col) = (-transitionMat[p_Deme][p_Niche][p_Spc][p_Sex][row][col]);
			}
			else if (row == col)
			{
				transMat(row, col) = (1.0 - transitionMat[p_Deme][p_Niche][p_Spc][p_Sex][row][col]);
			}
			else
			{
				transMat(row, col) = 0.0;
			}//end else
		}//end column loop
	}//end row loop

	//Calculates fundamental matrix (N)
	MatrixXd fundMat = transMat.inverse();

	//sets the mean life expectancy
	double tmp_Sum;

	for (col = 0; col < tmp_Stg; col++){
		tmp_Sum = 0.0;

		for (row = 0; row < tmp_Stg; row++){
			p_FundMat[row][col] = fundMat(row, col);
			tmp_Sum += fundMat(row, col);
		}//end column loop

		p_LifeExp[col] = tmp_Sum;
	}//end row loop

	//2.0 * diagonal matrix for fundamental matrix
	MatrixXd diag_FundMat_2(tmp_Stg, tmp_Stg);

	for (row = 0; row < tmp_Stg; row++){
		for (col = 0; col < tmp_Stg; col++)
		{
			if (row != col)
			{
				diag_FundMat_2(row, col) = 0.0;
			}
			else//diagonal element
			{
				diag_FundMat_2(row, col) = (2.0 * (fundMat(row, col))) - 1.0;
			}
		}//end column loop
	}//end row loop

	//squared fundamental matrix
	MatrixXd sq_FundMat(tmp_Stg, tmp_Stg);

	for (row = 0; row < tmp_Stg; row++){
		for (col = 0; col < tmp_Stg; col++)
		{
			sq_FundMat(row, col) = (fundMat(row, col)) * (fundMat(row, col));
		}//end column loop
	}//end row loop

	//variance matrix
	MatrixXd var_FundMat = (diag_FundMat_2 * fundMat) - sq_FundMat;

	for (col = 0; col < tmp_Stg; col++){
		for (row = 0; row < tmp_Stg; row++){
			p_Var_FundMat[row][col] = var_FundMat(row, col);
		}//end column loop
	}//end row loop
}

void Matrix_Population_Model::Set_AgeChar(void)
{
	//for females
	int deme, niche, sex, spc, stg, col, tmp_Stg;
	double *tmp_LifExp = new double[maxStg];//life expectancy

	//initialization
	for (stg = 0; stg < maxStg; stg++){
		tmp_LifExp[stg] = 0.0;
	}//end life stage loop

	double **tmp_FundMat;
	tmp_FundMat = new double*[maxStg];//fundimental matrix

	//initialization
	for (stg = 0; stg < maxStg; stg++){
		tmp_FundMat[stg] = new double[maxStg];//fundimental matrix
	}//end life stage loop

	double **tmp_Var_FundMat;
	tmp_Var_FundMat = new double*[maxStg];//fundimental matrix

	//initialization
	for (stg = 0; stg < maxStg; stg++){
		tmp_Var_FundMat[stg] = new double[maxStg];//fundimental matrix
	}//end life stage loop

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				for (sex = 0; sex < num_Sex; sex++){
					tmp_Stg = num_Stg[spc][sex];

					Set_FundMat(tmp_FundMat, tmp_Var_FundMat, tmp_LifExp, deme, niche, spc, sex);//returns the population growth rate (for female)

					//Fundimental matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							fundMat[deme][niche][spc][sex][stg][col] = tmp_FundMat[stg][col];
						}//end column loop
					}//end life stage loop

					//Variance of Fundimental matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							var_FundMat[deme][niche][spc][sex][stg][col] = tmp_Var_FundMat[stg][col];
						}//end column loop
					}//end life stage loop

					//Life expectancy
					for (stg = 0; stg < tmp_Stg; stg++){
						lifeExpectancy_Mean[deme][niche][spc][sex][stg] = tmp_LifExp[stg];
					}//end life stage loop
				}//end sex loop
			}//end species loop
		}//end niche loop
	}//end deme loop

	delete[] tmp_LifExp;

	for (stg = 0; stg < maxStg; stg++){
		delete[] tmp_Var_FundMat[stg];//fundimental matrix
	}//end life stage loop

	delete[] tmp_Var_FundMat;

	for (stg = 0; stg < maxStg; stg++){
		delete[] tmp_FundMat[stg];//fundimental matrix
	}//end life stage loop

	delete[] tmp_FundMat;
}

void Matrix_Population_Model::Set_Output(void)
{
	File_RW fileRW;//file write object
	fileRW.CSV_Create(fileName_Output);//creates a csv file

	int deme, niche, sex, spc, stg, col, tmp_Stg, tmp_Sex;
	int int_One = 1;

	double **k;
	k = new double*[1];
	k[0] = new double[1];

	string **s_K;
	s_K = new string*[1];
	s_K[0] = new string[1];

	string s_Sex;
	string s_Deme = "Deme";
	string s_Niche = "Niche";
	string s_Spc = "Species";

	string **s_Title;
	int s_Title_Row = 1;
	int s_Title_Col = 3;
	s_Title = new string*[s_Title_Row];

	for (spc = 0; spc < s_Title_Row; spc++){
		s_Title[spc] = new string[s_Title_Col];
	}//end row loop

	s_Title[0][0] = "Deme";
	s_Title[0][1] = "Niche";
	s_Title[0][2] = "Species";

	string **s_Tag;
	int s_Tag_Row = 1;
	int s_Tag_Col = 3;
	s_Tag = new string*[s_Title_Row];

	for (spc = 0; spc < s_Title_Row; spc++){
		s_Tag[spc] = new string[s_Title_Col];
	}//end row loop

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				//Title
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_Title, &s_Title_Row, &s_Title_Col);

				//Category information
				fileRW.Integer_To_String(&s_Tag[0][0], &deme);//deme
				fileRW.Integer_To_String(&s_Tag[0][1], &niche);//niche
				fileRW.Integer_To_String(&s_Tag[0][2], &spc);//species
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_Tag, &s_Tag_Row, &s_Tag_Col);

				////////////////////////////
				//lambda
				s_K[0][0] = "Lambda";
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

				k[0][0] = lamda_Pop[deme][niche][spc];
				fileRW.CSV_Write_Add_Double_2D(fileName_Output, k, &int_One, &int_One);
				////////////////////////////

				tmp_Sex = 1;//for females
				tmp_Stg = num_Stg[spc][tmp_Sex];
				double **tmp_C;
				tmp_C = new double*[tmp_Stg];//stable stage distribution

				for (stg = 0; stg < tmp_Stg; stg++){
					tmp_C[stg] = new double[int_One];
				}//end life stage loop

				///////////////////////////////////////////////
				//Stable stage distribution
				s_K[0][0] = "Stable Stage Distribution";
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

				for (stg = 0; stg < tmp_Stg; stg++){
					tmp_C[stg][0] = stableStageDist[deme][niche][spc][stg];
				}//end life stage loop

				fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_C, &tmp_Stg, &int_One);
				///////////////////////////////////////////////

				////////////////////////////
				//stabilizing density-dependent survival rate
				s_K[0][0] = "Density-Dependent-Survival Rate for Stabilizing Population Growth";
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

				k[0][0] = dds_Pop[deme][niche][spc];
				fileRW.CSV_Write_Add_Double_2D(fileName_Output, k, &int_One, &int_One);
				////////////////////////////


				double **tmp_FundMat;
				tmp_FundMat = new double*[maxStg];//fundimental matrix

				//initialization
				for (stg = 0; stg < maxStg; stg++){
					tmp_FundMat[stg] = new double[maxStg];//fundimental matrix
				}//end life stage loop

				//Age-related characteristics
				for (sex = 0; sex < num_Sex; sex++){
					tmp_Stg = num_Stg[spc][sex];

					//Life Expectancy
					if (sex == 0)
					{
						s_K[0][0] = "Male Life Expectancy";
					}
					else
					{
						s_K[0][0] = "Female Life Expectancy";
					}//end else

					fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);


					for (stg = 0; stg < tmp_Stg; stg++){
						tmp_C[stg][0] = lifeExpectancy_Mean[deme][niche][spc][sex][stg];
					}//end life stage loop

					fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_C, &tmp_Stg, &int_One);

					//Fundimental Matrix
					if (sex == 0)
					{
						s_K[0][0] = "Male Fundamental Matrix";
					}
					else
					{
						s_K[0][0] = "Female Fundamental Matrix";
					}//end else

					fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

					//Fundimental Matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							tmp_FundMat[stg][col] = fundMat[deme][niche][spc][sex][stg][col];
						}//end column loop
					}//end life stage loop

					fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_FundMat, &tmp_Stg, &tmp_Stg);

					//Variance of Fundimental Matrix
					if (sex == 0)
					{
						s_K[0][0] = "Male Variance Fundamental Matrix";
					}
					else
					{
						s_K[0][0] = "Female Variance Fundamental Matrix";
					}//end else

					fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

					//Fundimental Matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							tmp_FundMat[stg][col] = var_FundMat[deme][niche][spc][sex][stg][col];
						}//end column loop
					}//end life stage loop

					fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_FundMat, &tmp_Stg, &tmp_Stg);

					//Coefficient Variance of Fundimental Matrix
					if (sex == 0)
					{
						s_K[0][0] = "Male Coefficient Variance Fundamental Matrix";
					}
					else
					{
						s_K[0][0] = "Female Coefficient Variance Fundamental Matrix";
					}//end else

					fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

					//Coefficient Variance of Fundimental Matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							if (fundMat[deme][niche][spc][sex][stg][col] != 0.0)
							{
								tmp_FundMat[stg][col] = var_FundMat[deme][niche][spc][sex][stg][col] / fundMat[deme][niche][spc][sex][stg][col];
							}
							else
							{
								tmp_FundMat[stg][col] = 0.0;
							}//end else
						}//end column loop
					}//end life stage loop

					fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_FundMat, &tmp_Stg, &tmp_Stg);

					//Transition Matrix
					if (sex == 0)
					{
						s_K[0][0] = "Male Transition Matrix";
					}
					else
					{
						s_K[0][0] = "Female Transition Matrix";
					}//end else

					fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

					//Fundimental Matrix
					for (stg = 0; stg < tmp_Stg; stg++){
						for (col = 0; col < tmp_Stg; col++){
							tmp_FundMat[stg][col] = transitionMat[deme][niche][spc][sex][stg][col];
						}//end column loop
					}//end life stage loop

					fileRW.CSV_Write_Add_Double_2D(fileName_Output, tmp_FundMat, &tmp_Stg, &tmp_Stg);
				}//end sex loop

				for (stg = 0; stg < maxStg; stg++){
					delete[] tmp_FundMat[stg];//fundimental matrix
				}//end life stage loop

				delete[] tmp_FundMat;

				//adds a space
				s_K[0][0] = " ";
				fileRW.CSV_Write_Add_String_2D(fileName_Output, s_K, &int_One, &int_One);

				for (stg = 0; stg < tmp_Stg; stg++){
					delete[] tmp_C[stg];
				}//end life stage loop

				delete[] tmp_C;
			}//end species loop
		}//end niche loop
	}//end deme loop

	for (spc = 0; spc < s_Title_Row; spc++){
		delete[] s_Title[spc];
	}//end row loop

	delete[] s_Title;

	for (spc = 0; spc < s_Title_Row; spc++){
		delete[] s_Tag[spc];
	}//end row loop

	delete[] s_Tag;

	delete[] s_K[0];
	delete[] s_K;

	delete[] k[0];
	delete[] k;
}

void Matrix_Population_Model::Get_Stable_Stage_Dist(double**** p_StableStageDist)
{
	int deme, niche, spc, row, tmp_Stg;

	int tmp_Sex = 1;//for females

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				tmp_Stg = num_Stg[spc][tmp_Sex];

				for (row = 0; row < tmp_Stg; row++){
					p_StableStageDist[deme][niche][spc][row] = stableStageDist[deme][niche][spc][row];
				}//end row loop
			}//end species loop
		}//end niche loop
	}//end deme loop
}

void Matrix_Population_Model::Get_Stable_DDS(double*** p_DDS_Stable)
{
	int deme, niche, spc;

	for (deme = 0; deme < num_Deme; deme++){
		for (niche = 0; niche < num_Niche; niche++){
			for (spc = 0; spc < num_Spc; spc++){
				p_DDS_Stable[deme][niche][spc] = dds_Pop[deme][niche][spc];
			}//end species loop
		}//end niche loop
	}//end deme loop
}