#ifndef RANGEN_H_
#define RANGEN_H_

#pragma once
#include <iostream>
#include <boost/random/uniform_real_distribution.hpp>
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/variate_generator.hpp>

using namespace std;
using namespace boost::random;

class RanGen
{//generates random genotypes of a species
private:
	double** cumul_Alle_Frq;//dim[locus][allele type], cumulative allele frequency
	int n_Locus;//the number of loci
	int n_Allele;//the maximum number of allele types per locus

public:
	RanGen(const double** p_Alle_Frq, const int *p_n_Locus, const int *p_n_Allele);//
	~RanGen(void);
	void Get_Random_Gamete(unsigned short int *gamete, const int *p_num_Locus, variate_generator<mt19937&, uniform_real_distribution<> > &uni_Ran_Dev);
};

#endif /* RANGEN_H_ */