#pragma once
#include <vector>
#include <string>//for csv file
#include <cmath>
#include "File_RW.h"

using namespace std;

class Sum_Unit
{
private:
	int tot_Num_Combination;//The total number of case combinations
	int num_Category;//the number of categories = 7

	double *******data_Sum;//sum data vector; dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Mean;//mean data counter vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Squared_Sum_Difference;//the sum of squared difference to mean data counter vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_SD;//standard deviation data counter vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]

	double *******data_Max;//the maximum vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	double *******data_Min;//the minimum vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]

	int *******data_Counter;//counter data counter vector dim[category 1, category 2, category 3, category 4, category 5, category 6, category 7]
	int *tmp_End;//the number of classes for each category
	//the minimum number of classes per category is 1
	//category is integer starting from 0
	//class is integer starting from 0
public:
	Sum_Unit(vector<int> &p_Num_Class);
	~Sum_Unit();
	//Follow the call sequence below
	//1. Loop{ Update_Sum(vector<int> &p_Category_Set, double *p_Value) }
	//2. Set_Mean(void);
	//3. Loop{ Update_Squared_Sum_Difference(vector<int> &p_Category_Set, double *p_Value) }
	//4. Set_SD(void);
	//5. Write_Output_File(string *fileName_Tag)
	//6. De_Allocate_Memory(void);

	//updates the counter by one for a given category set
	void Update_Sum(vector<int> &p_Category_Set, double *p_Value);

	//sets means
	void Set_Mean(void);

	//updates the squared sum difference
	void Update_Squared_Sum_Difference(vector<int> &p_Category_Set, double *p_Value);

	//sets sample standard deviations
	void Set_SD(void);

	//writes an output file
	string Write_Output_File(string *fileName_Tag);

	//returns column headers for an output file
	void Get_Vector_String_Column_Header(vector<vector<string>> &tmp__Header_Str);
	//returns output data for an output file
	void Get_Vector_Double_Data(vector<vector<double>> &tmp_Data);

	//resets the counter
	void Reset_Data(void);

	//memory deallocation
	void De_Allocate_Memory(void);

	//returns the number of columns for the output file
	void Get_Num_Row_Output_File(int *p_Num_Row_Output, int *p_Num_Row_Header);

};

